'' ============================================================
'' Solid Body Simulation Sampler
''
'' Copyright (C) 2006-2007 - Jeff Marshall (coder@execulink.com)
''
'' License: 1) Program is provided as-is.  
''          2) There is no warranty or guarantee.
''          3) There are no other conditions.
''
'' Feel free to use, re-use, or abuse :)
''
'' ============================================================
''
'' Requires FreeBasic Compiler
''
'' Compile using:
''   fbc atoms.bas atomseng.bas vector.bas
''
'' ============================================================

#ifndef __FB_LANG__
Option Explicit
#endif
const False = 0, True = Not False

#include "atomseng.bi"

'These variables are set by default, but may be changed here
'ATOMSIZE = 4
'ATOMSPACE = 10
'MAXSPEED = 5
'YGRAVITY = -.004
'XGRAVITY = 0
'BOUNDDECAY = .99
'DEFORMFACTOR = .4
'DEFORMTHRESHOLD = 1
'BREAKTHRESHOLD = 2
'STIFFNESS = 0.5
'BONDTHRESHOLD = 0.5  '' 0.2 was used in atom_stick.bas
'SHOWATOMS = 1
'SHOWBONDS = 1

dim as integer grabatom, mx, my, mw, mb, oldmb, i, j
dim as single smx, smy
dim as string k, skipframe

screen 18, 8, 2
screenset 1, 0

ReStart:

Randomize Timer
ClearAllAtoms

If (command(1)) > "" then
	i = 1
	while command(i) > ""
		LoadSettings command(i)	
		i += 1
	wend
else

	'' Various shapes
	'' Func X,Y,XSize,YSize,Color [, rotation]
	CreateBlock  100,  150,  2,  5, 14, 0.1
	CreateBlock    0,  150,  2,  5, 13, 0.1
	CreateTriBlock 0,  100,  7,     15, 0.1
	CreateBlock -100,  150,  3,  3, 12, 0.1
	CreateBlock    0, 2000,  5,  5, 11, 0.1
	CreateBlock -100, 1000, 10,  3, 10, 0.1
	CreateBlock -100,  500, 10,  8,  9, 0.1
	CreateBlock -150, 3000,  5,  5, 11, 0.1
	CreateBlock -200,  500, 20,  1,  7, 0.2

	'' Create from a bitmap
	'                  filename  ,  w,  h,    x, y             , rotate
	'CreateBlockFromBmp "man.bmp", 13, 18, -100, 64 * ATOMSPACE, 0.1
	'CreateBlockFromBmp "man.bmp", 13, 18,    0, 48 * ATOMSPACE, 0.1
	'CreateBlockFromBmp "man.bmp", 13, 18,  100, 32 * ATOMSPACE, 0.1

end if

grabatom = 0

do
  oldmb = mb
  GetMouse mx, my, mw, mb
  smx = mx - 320
  smy = 480 - my

  if mb <> 0 and oldmb = 0 then
    grabatom = FindAtom(smx, smy)
  elseif mb = 0 then
    grabatom = 0
  end if

  if grabatom > 0 then
    if a(grabatom).ex = TRUE then
			a(grabatom).v.x = smx - a(grabatom).p.x
			a(grabatom).v.y = smy - a(grabatom).p.y
			if (mb and 2) then
				for i = 1 to NBONDS
					if b(i).a1 = grabatom then
						a(b(i).a2).v = a(grabatom).v
					elseif b(i).a2 = grabatom then
						a(b(i).a1).v = a(grabatom).v
					end if
				next i
			end if
    else
      grabatom = 0
    end if
  end if

	UpdateAtoms  
  cls
  DrawAtoms
  'screensync
  flip

  k = inkey
  select case k
  case "R", "r"
    goto Restart
  case " "
    for i = 1 TO NATOMS
      if a(i).ex = TRUE then
        VSet a(i).v, (rnd - 0.5) * MAXSPEED * 2, (rnd - 0.5) * MAXSPEED * 2
      end if
    next i
    
  end select

loop until k = chr(27)

screen 0
end
