#ifndef __ATOMSENG_BI__
#define __ATOMSENG_BI__

#include "vector.bi"

type Atom
  ex AS integer
  p AS vector
  v AS vector
  flg as integer
  c as integer
end type

type Bond
  ex AS integer
  a1 AS integer
  a2 AS integer
  ten AS single
  bal AS single
  c as integer
end type

declare sub ClearAllAtoms
declare function GetFreeAtom() as integer
declare function GetFreeBond() as integer
declare sub SetAtom (byval idx as integer, byval x1 as single, byval y1 as single, byval dx as single, byval dy as single, byval c as integer)
declare sub SetBond (byval idx as integer, byval a1 as integer, byval a2 as integer, byval bal as single, byval ten as single, byval c as integer)
declare sub RotateAtoms (byval x as single, byval y as single, byval r as single)
declare function FindAtom(byval x as single, byval y as single) as integer
declare function IsBond( byval aidx as integer, byval bidx as integer) as integer
declare sub ApplyBounds (byval i as integer)
declare sub ApplyCollision (byval i as integer)
declare sub ApplyTension (byval i as integer)
declare sub UpdateAtoms ()
declare sub DrawAtoms ()
declare sub CreateTriBlock(byval x1 as single, byval y1 as single, byval siz as integer, byval c as integer, byval rot as single = 0)
declare sub CreateBlock (byval x1 as single, byval y1 as single, byval xsiz as integer, byval ysiz as integer, byval c as integer, byval rot as single = 0)
declare sub CreateBlockFromImage(byval img as any ptr, byval w as integer, byval h as integer, byval x1 as single, byval y1 as single, byval c as integer, byval rot as single = 0)
declare sub CreateBlockFromBmp(byref f as string, byval w as integer, byval h as integer, byval x1 as single, byval y1 as single, byval c as integer, byval rot as single = 0)
declare sub LoadSettings(byref strFilename as string)

extern ATOMSIZE as single
extern ATOMSPACE as single

extern NATOMS as integer
extern NBONDS as integer

extern MAXSPEED as single
extern YGRAVITY as single
extern XGRAVITY as single

extern BOUNDDECAY as single
extern DEFORMFACTOR as single
extern DEFORMTHRESHOLD as single
extern BREAKTHRESHOLD as single
extern STIFFNESS as single
extern BONDTHRESHOLD as single

extern SHOWATOMS as integer
extern SHOWBONDS as integer

extern a() as Atom
extern b() as Bond

#endif